#include <iostream>
#include <stdio.h>
using namespace std;

struct produs
{
	int cod;
	char *denumire;
	float pret;
	float cant;
};

struct nodls 
{
	produs *inf;
	nodls *next;
	nodls *prev;
};

void inserare(nodls** cap, nodls** coada, produs* p)
{
	nodls* nou = (nodls*)malloc(sizeof(nodls));
	//nodls* nou = new nodls;
	//nou->inf = p;
	nou->inf = (produs*)malloc(sizeof(produs));
	nou->inf->cod = p->cod;
	nou->inf->denumire = (char*)malloc((strlen(p->denumire)+1)*
		sizeof(char));
	strcpy(nou->inf->denumire, p->denumire);
	nou->inf->pret = p->pret;
	nou->inf->cant = p->cant;
	//nou->next = NULL;
	if (*cap==NULL)
	{
		*cap = nou;
		*coada = nou;
		nou->prev = *cap;
		nou->next = *cap;
	}
	else
	{
		nodls* temp = *cap;
		while(temp->next !=*cap)
			temp = temp->next;
		temp->next = nou;
		nou->prev = temp;
		nou->next = *cap;
		*coada = nou;
	}
	//return cap;
}

void traversare(nodls *cap)
{
	nodls* temp = cap;
	while(temp->next!=cap)
	{
		printf("\nCod = %d, Denumire = %s, Pret = %5.2f, Cant = %5.2f",
			temp->inf->cod, temp->inf->denumire, temp->inf->pret, temp->inf->cant);
		temp = temp->next;
	}
	printf("\nCod = %d, Denumire = %s, Pret = %5.2f, Cant = %5.2f",
			temp->inf->cod, temp->inf->denumire, temp->inf->pret, temp->inf->cant);
}

void traversare_invers(nodls* cap, nodls *coada)
{
	nodls* temp = coada;
	while(temp!=cap)
	{
		printf("\nCod = %d, Denumire = %s, Pret = %5.2f, Cant = %5.2f",
			temp->inf->cod, temp->inf->denumire, temp->inf->pret, temp->inf->cant);
		temp = temp->prev;
	}
	printf("\nCod = %d, Denumire = %s, Pret = %5.2f, Cant = %5.2f",
			temp->inf->cod, temp->inf->denumire, temp->inf->pret, temp->inf->cant);
}

void dezalocare(nodls* cap)
{
	nodls* temp = cap;
	while(temp->next!=cap)
	{
		nodls* temp2 = temp->next;
		free(temp->inf->denumire);
		free(temp->inf);
		free(temp);
		temp = temp2;
	}
	free(temp->inf->denumire);
	free(temp->inf);
	free(temp);
}

void conversie(nodls *cap, char *denumire, produs **vect, int *nr)
{
	nodls *temp = cap;
	while(temp->next!=cap)
	{
		if(strcmp(temp->inf->denumire, denumire)==0)
		{
			//vect[*nr] = temp->inf;
			vect[*nr] = (produs*)malloc(sizeof(produs));
			vect[*nr]->cod = temp->inf->cod;
			vect[*nr]->denumire = (char*)malloc((strlen(temp->inf->denumire)+1)*
		sizeof(char));
			strcpy(vect[*nr]->denumire, temp->inf->denumire);
			vect[*nr]->pret = temp->inf->pret;
			vect[*nr]->cant = temp->inf->cant;
			(*nr)++;
		}
		temp = temp->next;
	}
	if(strcmp(temp->inf->denumire, denumire)==0)
	{
			//vect[*nr] = temp->inf;
			vect[*nr] = (produs*)malloc(sizeof(produs));
			vect[*nr]->cod = temp->inf->cod;
			vect[*nr]->denumire = (char*)malloc((strlen(temp->inf->denumire)+1)*
		sizeof(char));
			strcpy(vect[*nr]->denumire, temp->inf->denumire);
			vect[*nr]->pret = temp->inf->pret;
			vect[*nr]->cant = temp->inf->cant;
			(*nr)++;
	}
}

void stergereNodCodDat(nodls **cap, int codCautat)
{
	nodls* temp = *cap;
	while(temp->next!=*cap)
	{
		if(temp->inf->cod==codCautat)
		{
			nodls* p = temp->prev;
			nodls* q = temp->next;
			p->next = q;
			q->prev = p;
			free(temp->inf->denumire);
			free(temp->inf);
			free(temp);
			return;
		}
		else
			temp = temp->next;
	}
	if(temp->inf->cod==codCautat)
		{
			nodls* p = temp->prev;
			nodls* q = temp->next;
			p->next = q;
			q->prev = p;
			free(temp->inf->denumire);
			free(temp->inf);
			free(temp);
			//return;
		}
}

void main()
{
	nodls* cap = NULL, *coada = NULL;
	produs *p;
	int n;
	printf("Nr produse = ");
	scanf("%d", &n);
	char buffer[20];
	for(int i=0;i<n;i++)
	{
		p = (produs*)malloc(sizeof(produs));
		printf("\nCod = ");
		scanf("%d", &p->cod);
		printf("\nDenumire = ");
		scanf("%s", buffer);
		p->denumire = (char*)malloc((strlen(buffer)+1)*
			sizeof(char));
		strcpy(p->denumire, buffer);
		printf("\nPret = ");
		scanf("%f", &p->pret);
		printf("\nCant = ");
		scanf("%f", &p->cant);
		//cap = inserare(cap, p);
		inserare(&cap, &coada, p);
	}
	traversare(cap);
	printf("\n--------------\n");
	traversare_invers(cap, coada);
	printf("\n--------------\n");
	produs **vect = (produs**)malloc(n*sizeof(produs*));
	int nr = 0;
	conversie(cap, "apa", vect, &nr);
	//dezalocare(cap);
	for(int i=0;i<nr;i++)
		printf("\nCod = %d, Denumire = %s, Pret = %5.2f, Cant = %5.2f",
			vect[i]->cod, vect[i]->denumire, vect[i]->pret, vect[i]->cant);
	for(int i=0;i<nr;i++)
	{
		free(vect[i]->denumire);
		free(vect[i]);
	}
	free(vect);
	printf("\n--------------\n");
	stergereNodCodDat(&cap, 456);
	traversare(cap);
	dezalocare(cap);
}