#include <iostream>
#include <stdio.h>
using namespace std;

struct carte
{
	int cod;
	char *titlu;
	float pret;
};

struct nodStiva
{
	carte* inf;
	nodStiva* next;
};

struct nodLista
{
	carte* inf;
	nodLista* next;
};

void push(nodStiva** varf,carte* c)
{
	nodStiva *nou = (nodStiva*)malloc(sizeof(nodStiva));
	nou->inf = (carte*)malloc(sizeof(carte));
	nou->inf->cod = c->cod;
	nou->inf->titlu = (char*)malloc((strlen(c->titlu)+1)*
		sizeof(char));
	strcpy(nou->inf->titlu, c->titlu);
	nou->inf->pret = c->pret;
	nou->next = NULL;
	if(*varf==NULL)
		*varf = nou;
	else
	{
		nou->next = *varf;
		*varf = nou;
	}
}

int pop(nodStiva**varf, carte **val)
{
	if(*varf==NULL) return -1;
	else
	{
		*val = (carte*)malloc(sizeof(carte));
		(*val)->cod = (*varf)->inf->cod;
		(*val)->titlu = (char*)malloc((strlen((*varf)->inf->titlu)+1)*
			sizeof(char));
		strcpy((*val)->titlu, (*varf)->inf->titlu);
		(*val)->pret = (*varf)->inf->pret;
		nodStiva* temp = *varf;
		*varf = (*varf)->next;
		free(temp->inf->titlu);
		free(temp->inf);
		free(temp);
		return 0;
	}
}

void conversieVector(nodStiva** varf, carte**vect, int *nr)
{
	carte *c;
	while(pop(varf,&c)==0)
	{
		vect[*nr] = c;
		(*nr)++;
	}
}

void inserareLista(nodLista**cap, carte *c)
{
	nodLista *nou = (nodLista*)malloc(sizeof(nodLista));
	nou->inf = (carte*)malloc(sizeof(carte));
	nou->inf->cod = c->cod;
	nou->inf->titlu = (char*)malloc((strlen(c->titlu)+1)*
		sizeof(char));
	strcpy(nou->inf->titlu, c->titlu);
	nou->inf->pret = c->pret;
	nou->next = NULL;
	if(*cap==NULL)
		*cap = nou;
	else
	{
		nodLista* temp = *cap;
		while(temp->next) temp=temp->next;
		temp->next=nou;
	}
}

void conversieStivaLista(nodStiva** varf, nodLista **cap)
{
	carte *c;
	while (pop(varf, &c)==0)
	{
		inserareLista(cap, c);
	}
}

void traversare(nodStiva* varf)
{
	nodStiva* temp = varf;
	while(temp!=NULL)
	{
		printf("\nCod=%d, Titlu=%s, Pret=%5.2f",
			temp->inf->cod, temp->inf->titlu, temp->inf->pret);
		temp = temp->next;
	}
}

void traversareLista(nodLista* cap)
{
	nodLista* temp = cap;
	while(temp!=NULL)
	{
		printf("\nCod=%d, Titlu=%s, Pret=%5.2f",
			temp->inf->cod, temp->inf->titlu, temp->inf->pret);
		temp = temp->next;
	}
}

void dezalocareLista(nodLista *cap)
{
	nodLista* temp = cap;
	while(temp!=NULL)
	{
		nodLista* temp2 = temp->next;
		free(temp->inf->titlu);
		free(temp->inf);
		free(temp);
		temp = temp2;
	}
}

void main()
{
	int n;
	printf("Nr. carti = ");
	scanf("%d", &n);
	nodStiva *varf = NULL;
	carte *c = NULL;
	char buffer[20];
	for(int i=0;i<n;i++)
	{
		c = (carte*)malloc(sizeof(carte));
		printf("\nCod = ");
		scanf("%d", &c->cod);
		printf("\nTitlu = ");
		cin.getline(buffer, 20, '.');
		c->titlu = (char*)malloc((strlen(buffer)+1)*
			sizeof(char));
		strcpy(c->titlu, buffer);
		printf("\nPret = ");
		scanf("%f", &c->pret);
		push(&varf, c);
	}
	traversare(varf);

	carte* val = NULL;
	pop(&varf, &val);
	printf("\nCartea extrasa are codul=%d, titlul=%s si pretul %5.2f",
		val->cod, val->titlu, val->pret);

	//conversie stiva-vector
	/*carte** vect = (carte**)malloc(n*sizeof(carte*));
	int nr = 0;
	conversieVector(&varf, vect, &nr);
	for(int i=0;i<nr;i++)
		printf("\nCod=%d, Titlu=%s, Pret=%5.2f",
		vect[i]->cod, vect[i]->titlu, vect[i]->pret);
	for(int i=0;i<nr;i++)
	{
		free(vect[i]->titlu);
		free(vect[i]);
	}
	free(vect);*/

	nodLista*cap = NULL;
	conversieStivaLista(&varf, &cap);
	traversareLista(cap);
	dezalocareLista(cap);
}