#include <iostream>
#include <stdio.h>
using namespace std;

struct student
{
	int cod;
	char *nume;
	float medie;
};

struct nodCoada
{
	student* inf;
	nodCoada *next;
};

struct nodStiva
{
	student* inf;
	nodStiva *next;
};

void put(nodCoada** prim, nodCoada **ultim, student* s)
{
	nodCoada* nou = (nodCoada*)malloc(sizeof(nodCoada));
	nou->inf = (student*)malloc(sizeof(student));
	nou->inf->cod = s->cod;
	nou->inf->nume = (char*)malloc((strlen(s->nume)+1)*
		sizeof(char));
	strcpy(nou->inf->nume, s->nume);
	nou->inf->medie = s->medie;
	nou->next = NULL;
	if(*prim==NULL && *ultim==NULL)
	{
		*prim = nou;
		*ultim = nou;
	}
	else
	{
		(*ultim)->next = nou;
		*ultim = nou;
	}
}

int get(nodCoada** prim, nodCoada **ultim, student **val)
{
	if(*prim!=NULL && *ultim!=NULL)
	{
		(*val) = (student*)malloc(sizeof(student));
		(*val)->cod = (*prim)->inf->cod;
		(*val)->nume = (char*)malloc((strlen((*prim)->inf->nume)+1)*
			sizeof(char));
		strcpy((*val)->nume, (*prim)->inf->nume);
		(*val)->medie = (*prim)->inf->medie;
		nodCoada* temp = *prim;
		*prim = (*prim)->next;
		free(temp->inf->nume);
		free(temp->inf);
		free(temp);
		return 0;
	}
	else
		if(*prim==NULL)
		{
			*ultim = NULL;
			return -1;
		}
}

void push(nodStiva** varf, student* s)
{
	nodStiva *nou = (nodStiva*)malloc(sizeof(nodStiva));
	nou->inf = (student*)malloc(sizeof(student));
	nou->inf->cod = s->cod;
	nou->inf->nume = (char*)malloc((strlen(s->nume)+1)*
		sizeof(char));
	strcpy(nou->inf->nume, s->nume);
	nou->inf->medie = s->medie;
	nou->next = NULL;
	if(*varf==NULL)
		*varf = nou;
	else
	{
		nou->next = *varf;
		*varf = nou;
	}
}

int pop(nodStiva**varf, student **s)
{
	if(*varf==NULL) return -1;
	else
	{
		*s = (student*)malloc(sizeof(student));
		(*s)->cod = (*varf)->inf->cod;
		(*s)->nume = (char*)malloc((strlen((*varf)->inf->nume)+1)*
			sizeof(char));
		strcpy((*s)->nume, (*varf)->inf->nume);
		(*s)->medie = (*varf)->inf->medie;
		nodStiva* temp = *varf;
		*varf = (*varf)->next;
		free(temp->inf->nume);
		free(temp->inf);
		free(temp);
		return 0;
	}
}

void traversare(nodCoada *prim)
{
	nodCoada* temp = prim;
	while(temp!=NULL)
	{
		printf("\nCod=%d, Nume=%s, Medie=%5.2f",
			temp->inf->cod, temp->inf->nume, temp->inf->medie);
		temp=temp->next;
	}
}

void traversareStiva(nodStiva *varf)
{
	nodStiva* temp = varf;
	while(temp!=NULL)
	{
		printf("\nCod=%d, Nume=%s, Medie=%5.2f",
			temp->inf->cod, temp->inf->nume, temp->inf->medie);
		temp=temp->next;
	}
}

void conversieCoadaStiva(nodCoada** prim, nodCoada** ultim, nodStiva **varf)
{
	student *s;
	while(get(prim, ultim, &s)==0)
		push(varf, s);
}

void main()
{
	int n;
	printf("Nr studenti=");
	scanf("%d", &n);
	nodCoada* prim=NULL, *ultim=NULL;
	char buffer[20];
	student *s;
	for(int i=0;i<n;i++)
	{
		s = (student*)malloc(sizeof(student));
		printf("\nCod=");
		scanf("%d", &s->cod);
		printf("\nNume=");
		scanf("%s", buffer);
		s->nume = (char*)malloc((strlen(buffer)+1)*
			sizeof(char));
		strcpy(s->nume, buffer);
		printf("\nMedie=");
		scanf("%f", &s->medie);
		put(&prim, &ultim, s);
	}
	traversare(prim);

	student* extras;
	get(&prim, &ultim, &extras);
	printf("\nStudentul extras are codul=%d, numele=%s, media=%5.2f",
		extras->cod, extras->nume, extras->medie);

	nodStiva* varf=NULL;
	conversieCoadaStiva(&prim, &ultim, &varf);
	traversareStiva(varf);

	while(pop(&varf, &extras)==0);
}